#!/usr/bin/env python 

from movieClass import *

from xml.dom.ext.reader.Sax import FromXmlFile, FromXmlStream
from xml.dom.minidom import parseString

class Movies:

    def __init__(self):
	self.library = []
    
    def read_from_file(self,aFilename):
	if aFilename.endswith('.xml'):
	  doc = FromXmlFile(aFilename)
	  if len(doc.getElementsByTagName("movies")) == 1:
	    return self.read_from_xml_tag(doc.getElementsByTagName("movies")[0])
	  else:
	    return None
	else:
	  return None
    read_from_file = classmethod(read_from_file)

    def read_from_srt(self,anXMLString):
	doc = parseString(anXMLString)
	if len(doc.getElementsByTagName("movies")) == 1:
	  return self.read_from_xml_tag(doc.getElementsByTagName("movies")[0])
	else:
	  return None
    read_from_srt = classmethod(read_from_srt)

    def read_from_xml_tag(self, anXMLTag):
	anInstance = Movies()
	if len(anXMLTag.getElementsByTagName("movie-info")) > 0 :
	  for aMovieInfoTag in anXMLTag.getElementsByTagName("movie-info"):
	    anInstance.library.append(Movie.read_from_xml_tag(aMovieInfoTag))
	  return anInstance
	else:
	 return None
    read_from_xml_tag = classmethod(read_from_xml_tag)

    def add(self, aMovie):
        self.library.append(aMovie)

    def index_of(self,aMovie):
        self.library.find(aMovie)
        
    def remove(self, aMovie):
        self.library.remove(aMovie)

    def get_list(self):
        return self.library

    def clear(self):
        del self.library[:]

    def to_xml(self, leftOffset = 0):
        offsetString = leftOffset * (' ')
        xml = '%(offset)s<movies>\n' % {'offset':offsetString }
        for aMovie in self.library:
            xml += aMovie.to_xml(leftOffset=2) + '\n'
        xml += '%(offset)s</movies>\n' % {'offset':offsetString }
        return xml

    def find(self, title, matchCase=False):
        for aMovie in self.library:
            if matchCase:
                if aMovie.title == title:
                    return aMovie
            else:
                movieTitleUpperCased = aMovie.title.title()
                titleToFindUpperCased = title.title()
                if movieTitleUpperCased == titleToFindUpperCased:
                    return aMovie
        return None

    def find_reference(self, reference, matchCase=False):
        for aMovie in self.library:
            if matchCase:
                if aMovie.reference == reference:
                    return aMovie
            else:
                movieReferenceUpperCased = aMovie.reference.title()
                referenceToFindUpperCased = reference.title()
                if movieTitleUpperCased == titleToFindUpperCased:
                    return aMovie
        return None

